<?php
namespace Teknisa\GOP\Modules\Relatorio\Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification; 

class Gop13000VerificacaoPendencias extends \Teknisa\GER\Controllers\TeknisaCrud{

    protected $dataSourceManager;
    protected $connection;
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection) {
        $this->connection  = $connection;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function dataParametro (DTO\Request $request, DTO\Response $response){
        $rows = $request->getFilterCriteria()->getConditions();
        $data = $this->crudService->getFilteredDataSet('gop00200_filialoperop', $rows)->getRows();
        $flag = false;
        $rowCopy = [];
        
        $cdfilial = array_filter($rows, function($name) {
            return $name == 'P_CDFILIAL';
        });
        $cdoperador = array_filter($rows, function ($e) {
            return $e["columnName"] === "P_CDOPERADOR";
        });
        if(sizeof($cdoperador) > 1){
            $filtroGeral = array(
                array(
                    "columnName" => "P_CDOPERADOR",
                    "operator" => "=",
                    "value" => $cdoperador[0]["value"]
                )
            );
        }else{
            $filtroGeral = array();
        }
        
        $geral = $this->crudService->getFilteredDataSet('gop13000_geral', $filtroGeral)->getRows();
        if(!empty($geral)){
            $max = sizeof($data);
            if($max > 4){
                if( $data[4]["CDNMFILIAL"] != "Geral"){
                    $flag = true;
                }
            }else{
                $flag = true;
            }
            if($flag){
                $copyData = $data;
                for ($i = 0; $i < $max; $i++) {
                    if($data[$i]["IDACESSOCALC"] == "S"){
                        $status = "Sim";
                    }else{
                        $status = "Não";
                    }
                    $data[$i]["DESCRICAO"] = "Acesso ao Cálculo";
                    $data[$i]["STATUS"] = $status;
                }
                foreach ($copyData as $rowCopy) {
                    if($rowCopy["IDACESSOAPROV"] == "S"){
                        $status = "Sim";
                    }else{
                        $status = "Não";
                    }
                array_push($data, 
                    [
                        "CDFILIAL" => $rowCopy["CDFILIAL"], 
                        "CDNMFILIAL" => $rowCopy["CDNMFILIAL"], 
                        "DESCRICAO"  => "Acesso à Aprovação",
                        "STATUS"     => $status
                    ]
                );
                }
                $maxGeral = sizeof($geral);
                
                for ($i = 0; $i < $maxGeral; $i++) {
                    if($geral[$i]["STATUS"] == "S"){
                        $status = "Sim";
                    }else{
                        $status = "Não";
                    }
                    $geral[$i]["STATUS"] = $status;
                }
                
                foreach ($geral as $rowGeral) {
                    if(!empty($rowCopy)){
                        if($rowCopy["IDACESSOAPROV"] == "S"){
                            $status = "Sim";
                        }else{
                            $status = "Não";
                        }
                    }
                    if($rowGeral["IDROTINA"] == '1PARAM'){
                        $rowGeral["DESCRICAO"] = "Realizar parametrização no elemento 'Parâmetros para Orçamento Operacional'.";
                    }else if($rowGeral["IDROTINA"] == '2GRUPOGERENTE'){
                        $rowGeral["DESCRICAO"] = "Cadastrar grupo de gerentes no elemento 'Controle de Unidades por Gerente'.";
                    }else if($rowGeral["IDROTINA"] == '3GERENTEGRUPO'){
                        $rowGeral["DESCRICAO"] = "Cadastrar gerentes nos grupos do elemento 'Controle de Unidades por Gerente'.";
                    }else if($rowGeral["IDROTINA"] == '4ACESSOCALC'){
                        $rowGeral["DESCRICAO"] = "Permitir acesso ao cálculo para gerentes do elemento 'Controle de Unidades por Gerente'.";
                    }else if($rowGeral["IDROTINA"] == '5ACESSOAPROV'){
                        $rowGeral["DESCRICAO"] = "Permitir acesso à aprovação para gerentes do elemento 'Controle de Unidades por Gerente'.";
                    }
                    array_unshift($data, $rowGeral);
                }
            }
        }
        $response->addDataSet(new DataSet("gop13000_verificacao_parametro", $data));
    }
    
    public function dataOperacional (DTO\Request $request, DTO\Response $response){
        $rows = $request->getFilterCriteria()->getConditions();
        $data = $this->crudService->getFilteredDataSet('gop13000_verificacao_pendencias', $rows)->getRows();
        $max = sizeof($data);
        for ($i = 0; $i < $max; $i++) {
            if($data[$i]["IDROTINA"] == "ORCAMENTO"){
                $data[$i]["DESCRICAO"] = 'Orçamento a ser concluído';
            }else if($data[$i]["IDROTINA"] == 'APROVACAO'){
                $data[$i]["DESCRICAO"] = 'Conclusão do orçamento a ser aprovada';
            }else{
                 $data[$i]["DESCRICAO"] = 'Etapa de preparação do orçamento a ser concluída';
            }
        }
        $response->addDataSet(new DataSet("gop13000_verificacao_operacional", $data));
    }
}